diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/test/ns3wifi/wifi-ac-mapping-test-suite.cc ns-3.34/src/test/ns3wifi/wifi-ac-mapping-test-suite.cc
--- ns-3.33/src/test/ns3wifi/wifi-ac-mapping-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/test/ns3wifi/wifi-ac-mapping-test-suite.cc	2021-07-14 10:31:07.000000000 -0700
@@ -41,19 +41,47 @@
 
 NS_LOG_COMPONENT_DEFINE ("WifiAcMappingTest");
 
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Test for User priority to Access Category mapping
+ */
 class WifiAcMappingTest : public TestCase
 {
 public:
+  /**
+   * Constructor for WifiAcMappingTest
+   *
+   * \param tos the type of service
+   * \param expectedQueue the expected queue disc index
+   */
   WifiAcMappingTest (uint8_t tos, uint8_t expectedQueue);
   virtual void DoRun (void);
 
 private:
+  /**
+   * Function called whenever a packet is enqueued in
+   * a queue disc.
+   *
+   * \param tos the type of service
+   * \param count the pointer to the packet counter
+   * \param item the enqueued item
+   */
   static void PacketEnqueuedInQueueDisc (uint8_t tos, uint16_t* count, Ptr<const QueueDiscItem> item);
+  /**
+   * Function called whenever a packet is enqueued in
+   * a Wi-Fi MAC queue.
+   *
+   * \param tos the type of service
+   * \param count the pointer to the packet counter
+   * \param item the enqueued item
+   */
   static void PacketEnqueuedInWifiMacQueue (uint8_t tos, uint16_t* count, Ptr<const WifiMacQueueItem> item);
-  uint8_t m_tos;
-  uint16_t m_expectedQueue;
-  uint16_t m_QueueDiscCount[4];
-  uint16_t m_WifiMacQueueCount[4];
+  uint8_t m_tos; //!< type of service
+  uint16_t m_expectedQueue; //!< expected queue disc index
+  uint16_t m_QueueDiscCount[4]; //!< packet counter per queue disc
+  uint16_t m_WifiMacQueueCount[4]; //!< packet counter per Wi-Fi MAC queue
 };
 
 WifiAcMappingTest::WifiAcMappingTest (uint8_t tos, uint8_t expectedQueue)
@@ -242,7 +270,12 @@
   Simulator::Destroy ();
 }
 
-
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Access category mapping Test Suite
+ */
 class WifiAcMappingTestSuite : public TestSuite
 {
 public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/test/ns3wifi/wifi-issue-211-test-suite.cc ns-3.34/src/test/ns3wifi/wifi-issue-211-test-suite.cc
--- ns-3.33/src/test/ns3wifi/wifi-issue-211-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/test/ns3wifi/wifi-issue-211-test-suite.cc	2021-07-14 10:31:07.000000000 -0700
@@ -125,7 +125,6 @@
   spectrumChannel->SetPropagationDelayModel (delayModel);
 
   SpectrumWifiPhyHelper phy;
-  phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
   phy.SetChannel (spectrumChannel);
 
   WifiHelper wifi;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/test/ns3wifi/wifi-msdu-aggregator-test-suite.cc ns-3.34/src/test/ns3wifi/wifi-msdu-aggregator-test-suite.cc
--- ns-3.33/src/test/ns3wifi/wifi-msdu-aggregator-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/test/ns3wifi/wifi-msdu-aggregator-test-suite.cc	2021-07-14 10:31:07.000000000 -0700
@@ -34,6 +34,12 @@
 
 using namespace ns3;
 
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Throughput test for MsduAggregator
+ */
 class WifiMsduAggregatorThroughputTest : public TestCase
 {
 public:
@@ -41,7 +47,7 @@
   virtual void DoRun (void);
 
 private:
-  bool m_writeResults;
+  bool m_writeResults; //!< flag whether to generate pcap
 };
 
 WifiMsduAggregatorThroughputTest::WifiMsduAggregatorThroughputTest ()
@@ -150,6 +156,7 @@
   // Enable tracing at the AP
   if (m_writeResults)
     {
+      wifiPhy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
       wifiPhy.EnablePcap ("wifi-amsdu-throughput", sta.Get (0)->GetId (), 0);
     }
 
@@ -181,9 +188,16 @@
 }
 
 
-// For now the MSDU Aggregator Test Suite contains only the one test
-// that is defined in this file, so it's class definition and
-// instantiation can live here.
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief MsduAggregator Test Suite
+ *
+ * For now the MSDU Aggregator Test Suite contains only the one test
+ * that is defined in this file, so it's class definition and
+ * instantiation can live here.
+ */
 class WifiMsduAggregatorTestSuite : public TestSuite
 {
 public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/test/wscript ns-3.34/src/test/wscript
--- ns-3.33/src/test/wscript	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/test/wscript	2021-07-14 10:31:07.000000000 -0700
@@ -31,6 +31,8 @@
     test_test.source = [
         'csma-system-test-suite.cc',
         'ns3tc/fq-codel-queue-disc-test-suite.cc',
+        'ns3tc/fq-cobalt-queue-disc-test-suite.cc',
+        'ns3tc/fq-pie-queue-disc-test-suite.cc',
         'ns3tc/pfifo-fast-queue-disc-test-suite.cc',
         'ns3tcp/ns3tcp-cwnd-test-suite.cc',
         'ns3tcp/ns3tcp-interop-test-suite.cc',
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/topology-read/bindings/modulegen__gcc_ILP32.py ns-3.34/src/topology-read/bindings/modulegen__gcc_ILP32.py
--- ns-3.33/src/topology-read/bindings/modulegen__gcc_ILP32.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/topology-read/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:07.000000000 -0700
@@ -71,12 +71,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -356,8 +360,10 @@
     register_Ns3DefaultDeleter__Ns3TraceSourceAccessor_methods(root_module, root_module['ns3::DefaultDeleter< ns3::TraceSourceAccessor >'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1173,6 +1179,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1386,6 +1404,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1461,6 +1484,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1481,6 +1516,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/topology-read/bindings/modulegen__gcc_LP64.py ns-3.34/src/topology-read/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/topology-read/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/topology-read/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
@@ -71,12 +71,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -356,8 +360,10 @@
     register_Ns3DefaultDeleter__Ns3TraceSourceAccessor_methods(root_module, root_module['ns3::DefaultDeleter< ns3::TraceSourceAccessor >'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1173,6 +1179,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1386,6 +1404,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1461,6 +1484,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1481,6 +1516,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/topology-read/examples/topology-example-sim.cc ns-3.34/src/topology-read/examples/topology-example-sim.cc
--- ns-3.33/src/topology-read/examples/topology-example-sim.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/topology-read/examples/topology-example-sim.cc	2021-07-14 10:31:07.000000000 -0700
@@ -68,8 +68,11 @@
 
 NS_LOG_COMPONENT_DEFINE ("TopologyCreationExperiment");
 
-static std::list<unsigned int> data;
-
+/**
+ * Print the TTL of received packet
+ * \param p received packet
+ * \param ad sender address
+ */
 static void SinkRx (Ptr<const Packet> p, const Address &ad)
 {
   Ipv4Header ipv4;
@@ -130,7 +133,7 @@
   stack.SetRoutingHelper (nixRouting);  // has effect on the next Install ()
   stack.Install (nodes);
 
-  NS_LOG_INFO ("creating ip4 addresses");
+  NS_LOG_INFO ("creating IPv4 addresses");
   Ipv4AddressHelper address;
   address.SetBase ("10.0.0.0", "255.255.255.252");
 
@@ -157,7 +160,7 @@
     }
 
   // it crates little subnets, one for each couple of nodes.
-  NS_LOG_INFO ("creating ipv4 interfaces");
+  NS_LOG_INFO ("creating IPv4 interfaces");
   Ipv4InterfaceContainer* ipic = new Ipv4InterfaceContainer[totlinks];
   for (int i = 0; i < totlinks; i++)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/topology-read/model/rocketfuel-topology-reader.cc ns-3.34/src/topology-read/model/rocketfuel-topology-reader.cc
--- ns-3.33/src/topology-read/model/rocketfuel-topology-reader.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/topology-read/model/rocketfuel-topology-reader.cc	2021-07-14 10:31:07.000000000 -0700
@@ -65,13 +65,19 @@
 /* uid @loc [+] [bb] (num_neigh) [&ext] -> <nuid-1> <nuid-2> ... {-euid} ... =name[!] rn */
 
 
+/// Maximum nuber of matches in a regex query
 #define REGMATCH_MAX 16
 
+/// Start of a line
 #define START "^"
+/// End of a line
 #define END "$"
+/// One or more spaces
 #define SPACE "[ \t]+"
+/// Zero or more spaces
 #define MAYSPACE "[ \t]*"
 
+/// Regex expression matching a MAP line
 #define ROCKETFUEL_MAPS_LINE \
   START "(-*[0-9]+)" SPACE "(@[?A-Za-z0-9,+]+)" SPACE \
   "(\\+)*" MAYSPACE "(bb)*" MAYSPACE \
@@ -81,6 +87,7 @@
   "=([A-Za-z0-9.!-]+)" SPACE "r([0-9])" \
   MAYSPACE END
 
+/// Regex expression matching a WEIGHT line
 #define ROCKETFUEL_WEIGHTS_LINE \
   START "([^ \t]+)" SPACE "([^ \t]+)" SPACE "([0-9.]+)" MAYSPACE END
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/topology-read/model/rocketfuel-topology-reader.h ns-3.34/src/topology-read/model/rocketfuel-topology-reader.h
--- ns-3.33/src/topology-read/model/rocketfuel-topology-reader.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/topology-read/model/rocketfuel-topology-reader.h	2021-07-14 10:31:07.000000000 -0700
@@ -108,9 +108,10 @@
   /**
    * \brief Classifies the file type according to its content.
    *
+   * \param buf the first line of the file being read
    * \return The file type (RF_MAPS, RF_WEIGHTS, or RF_UNKNOWN)
    */
-  enum RF_FileType GetFileType (const char *);
+  enum RF_FileType GetFileType (const char *buf);
 
   int m_linksNumber; //!< Number of links.
   int m_nodesNumber; //!< Number of nodes.
